#!/usr/bin/env python4
# -*- coding: utf-8 -*-

# StartOS Device Manager(ydm).
# Copyright (C) 2011 ivali, Inc.
# hechao <hechao@ivali.com>, 2011.

#__author__="hechao"
#__date__ ="$2011-12-20 16:36:20$"

#import gtk
import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk
import time
import os
#import pango
from gi.repository import Pango
import re
from gi.repository import GObject
import gettext
from syscall import *
from globals import *
from widgets import BaseFucn
import sys

gettext.textdomain('ydm')
def _(s):
    return gettext.gettext(s)

F = lambda x: "%1.f"%x if x*10 % 10 == 0 else "%1.2f"%x

class Computer(Gtk.VBox, BaseFucn):

    def __init__(self, product=""):
        Gtk.VBox.__init__(self)
        tmp = re.findall("\[(.*)\]", product[-11:])
        if tmp:
            self.pcid = tmp[0]
        else:self.pcid = ""
    def title_box(self, text):

        label = Gtk.Label()
        label.set_markup("<span foreground='#1C242D' font_desc='10'><b>%s</b></span>" %text)

        hbox = Gtk.HBox()
        hbox.pack_start(label, False, False, 0)

        align = self.box_align(hbox, 10, 20)
        self.pack_start(align, False, False, 0)

    def tag_box(self, text, record=None):

        label = Gtk.Label()
        label.set_alignment(0, 0)
        label.set_width_chars(15)
        label.set_markup("<span foreground='#1A3E88' font_desc='10'>%s</span>" % text)

        hbox = Gtk.HBox()
        hbox.pack_start(label, False, False, 0)

        if record:
            self.temp = Gtk.Label()
            self.temp.set_selectable(True)
            hbox.pack_start(self.temp, False, False, 0)

            GObject.timeout_add(2000, self.updates, record)

        align = self.box_align(hbox, 8, 20)
        self.pack_start(align, False, False, 0)

    def updates(self, record):
        '''refresh temperature'''
        val = ""
        if record == "cpu":
            val = cpu_sensor()
        else:
            val = disk_sensor(record)
        if not val:
            return False

        r = re.match("\d+",val)
        if r:
            if int(r.group()) >= 60:
                val = "<span color='red'>%s</span>" %val

        self.temp.set_tooltip_text(val)
        text = _("Current temperature:")
        self.temp.set_markup("<span foreground='#1A3E88' font_desc='10'>%s</span>" %(text + val))

        return True

    def body_box(self, bodys):

        for body in bodys:
            if not body[1]:
                continue

            leftlabel = Gtk.Label()
            leftlabel.set_alignment(0, 0)
            leftlabel.set_width_chars(15)
            leftlabel.set_markup("<span font_desc='10'>%s</span>" %body[0])

            hbox = Gtk.HBox()
            hbox.pack_start(leftlabel, False, False, 0)

            self.rigthlabel = Gtk.Label()
            self.rigthlabel.set_alignment(0, 0)
            self.rigthlabel.set_selectable(True)
            self.rigthlabel.set_markup("<span font_desc='10'>%s</span>" %body[1])

            length = len(body[1])
            if length >= 50:
                l = length // 50
                s = ""
                for i in range(1, l + 1):
                    s += body[1][(i-1)*50:i*50] + "\n"
                s += body[1][i*50:]
                self.rigthlabel.set_tooltip_text(s)
            else:
                self.rigthlabel.set_tooltip_text(body[1])

            hbox.pack_start(self.rigthlabel, False, False, 0)
            align = self.box_align(hbox, 7, 20)

            ebox = Gtk.EventBox()
            ebox.set_visible_window(False)
            #ebox = self.default_ebox()
            ebox.connect("size-allocate", self.label_align)
            ebox.add(align)
            self.pack_start(ebox, False, False, 0)

    def label_align(self, widget, event):
        self.rigthlabel.set_ellipsize(Pango.EllipsizeMode.END)

    def box_align(self, widget, top, left):

#        align = Gtk.Alignment(0.0, 0.0, 1.0, 1.0)
        align = Gtk.Alignment()
        align.set_padding(top, 0, left, left)

        align.add(widget)
        return align

    def dev_logo(self, vendor="", product=""):

        icon_url = self.match_vid(vendor, product)
        if not icon_url:
            return None
        icon, url, name = icon_url
        button = self.ebox_button()
        button.connect('button-press-event', self.click_on, url)

        vbox = Gtk.VBox()

        label = Gtk.Label()
        label.set_markup("<span foreground='#1A3E88' font_desc='10'>%s</span>" % _(name))
        image = Gtk.Image.new_from_file(LOGO + icon)

        vbox.pack_start(image, False, False, 0)
        vbox.pack_start(label, False, False, 8)
        button.add(vbox)

        align = self.box_align(button, 10, 50)
        return align

    def match_vid(self, v, p=""):

        def get_url(v, p):
            '''vendors'''
            listv=v.split(" ")
            v = v.split(" ")[0]
            tmp = re.findall("([a-zA-Z0-9-]+)", v)
            if tmp:
                url = VENDORS.get(tmp[0].upper())
                if url:
                    return url
                else:
                    if ( len(listv) >  1): #some one like: "SK Hynix"
                        path=listv[0]+listv[1]
                        tm=re.findall("([a-zA-Z0-9-]+)", path)
                        url=VENDORS.get(tm[0].upper())
                        if url:
                            return url
                        else:
                            p = p.split(" ")[0]
                            url = VENDORS.get(p.upper())
                            if url:
                                return url
                    else:
                        p = p.split(" ")[0]
                        url = VENDORS.get(p.upper())
                        if url:
                            return url
            else:
                p = p.split(" ")[0]
                url = VENDORS.get(p.upper())
                if url:
                    return url

        tmp = re.findall("\[(.*)\]", v[-6:])
        if tmp:
            '''ID'''
            url = VENDORS.get(tmp[0])
            if url:
                return url
            else:
                return get_url(v, p)
        else:
            return get_url(v, p)

    def click_on(self, widget, event, url):
        os.system("xdg-open http://%s &" % url)

    def debug_dm(self, strm):
        pf = "/tmp/ydm-debug.txt"
        f = open(pf, "a+")
        f.write(strm)
        f.close()

class System(Computer):

    category = "system"

    def __init__(self, description, product, vendor, version, serial, width, config, capability):
        Computer.__init__(self, product)

        if not description:
            return

        self.title_box(_("Computer preview"))
        self.tag_box(_("Basic Info"))

        #get product,vendor,serial. if product is non.
        if product == "":
             try:
                cmd="/usr/sbin/dmi-smbios3"
                result=os.popen('%s -t 1' % cmd)
                res=result.read()
                for line in res.splitlines():
                    #get product info.
                    f="Product Name:"
                    if f in line:
                        m=line.split(f)
                        product = m[1].strip()
                    #vendor
                    if vendor == "":
                        f="Manufacturer:"
                        if f in line:
                            m=line.split(f)
                            vendor = m[1].strip()
                    #serial
                    if serial == "":
                        f="Serial Number:"
                        if f in line:
                            m=line.split(f)
                            serial = m[1].strip()
             except:pass 
        #end

        bodys = []
        bodys.append((_("CDescription"), description))
        bodys.append((_("CProduct"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Serial"), serial))
        bodys.append((_("UUID"), config.get("uuid")))
        self.body_box(bodys)

        self.tag_box(_("System Info"))

        del bodys[:]
        bodys.append((_("Hostname"), host_name()))
        bodys.append((_("Username"), user()))

        up_time = uptime()
        day = up_time.get("day")
        runtime = ""
        if day:
            runtime = day + _("day")
        hour = up_time.get("hour")
        if hour:
            runtime += hour + _("hour")
        minute = up_time.get("minute")
        if minute:
            runtime += minute + _("minute")
        
        bodys.append((_("Runtime"), runtime))
        bodys.append((_("System version"), os_version()))
        bodys.append((_("Install time"), install_time()))

        release, machine = kernel()
        bodys.append((_("Kernel version"), version_release()))
        bodys.append((_("Kernel arch"), machine))

        bodys.append((_("Xorg version"), xorg()))

        glinfo = opengl()
        if glinfo:
            bodys.append((_("Rendering"), glinfo[0]))
            bodys.append((_("OpenGL version"), glinfo[2]))
            bodys.append((_("OpenGL renderer"), glinfo[1]))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Motherboard(Computer):

    category = "motherboard"

    def __init__(self, description, product, vendor, version, serial):
        Computer.__init__(self, product)

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("MProduct"), product))
        bodys.append((_("MVendor"), vendor))
        bodys.append((_("Serial"), serial))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Bios(Computer):

    category = "bios"

    def __init__(self, description, product, vendor, version, date, size, capability):
        Computer.__init__(self, product)

        self.tag_box("BIOS" + _("Info"))

        bodys = []
        bodys.append((_("BVendor"), vendor))
        bversion=get_bios_ver()
        if bversion:
            bodys.append((_("BVersion"), bversion))
        else: 
            bodys.append((_("BVersion"), version))

        try:
            date = time.strptime(date,"%m/%d/%Y")
            date = time.strftime("%Y-%m-%d", date)
        except:pass
        bodys.append((_("Date"), date))

        text = ",".join(capability)
        bodys.append((_("BCapability"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

def GetCpuCacheInfo():
    import os
    p=os.popen('lscpu') 
    x=p.readlines()
    obj={
        "L1d":"0",
        "L1i":"0",
        "L2":"0",
        "L3":"0"
    }
    for lin in x:
        lin = lin.replace("\n","").replace("\r","")
        findstate=lin.find("L1d")
        if(findstate>=0):
            obj["L1d"]=lin[lin.find("   "):].replace(" ","")
        findstate=lin.find("L1i")
        if(findstate>=0):
            obj["L1i"]=lin[lin.find("   "):].replace(" ","")
        findstate=lin.find("L2")
        if(findstate>=0):
            obj["L2"]=lin[lin.find("   "):].replace(" ","")
        findstate=lin.find("L3")
        if(findstate>=0):
            obj["L3"]=lin[lin.find("   "):].replace(" ","")
    return obj

class Cpu(Computer):
    category = "cpu" 

    def __init__(self, description, product, vendor, version, businfo, serial, slot, size, capacity, width, clock, config, capability):
        Computer.__init__(self, product)

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"), "cpu")

        bodys = []
        bodys.append((_("cpu"), product))
        bodys.append((_("Vendor"), vendor))

        if size:
            size = str(int(size) / 1000000) + "MHz"
            bodys.append((_("Current Hz"), size))
        if clock:
            clock = str(int(clock) / 1000000) + "MHz"
            bodys.append((_("External Hz"), clock))
        if size == "":
            try:
               cmd="/usr/sbin/dmi-smbios3"
               result=os.popen('%s -t 4' % cmd)
               res=result.read()
               for line in res.splitlines():
                   f="Current Speed:"
                   if f in line:
                      m=line.split(f)
                      size = m[1].strip()
                   if clock == "":
                      f="External Clock:"
                      if f in line:
                         m=line.split(f)
                         clock = m[1].strip()
                   if capacity == "":
                      f="Max Speed:"
                      if f in line:
                         m=line.split(f)
                         capacity = m[1].strip()
                   if version == "":
                      f="Version:"
                      if f in line:
                        m=line.split(f)
                        version = m[1].strip()
                   if product == "":
                      f="Manufacturer:"
                      if f in line:
                        m=line.split(f)
                        product = m[1].strip()
            except:pass
        bodys.append((_("cpu"), product))
        bodys.append((_("Current Hz"), size))
        bodys.append((_("External Hz"), clock))
        bodys.append((_("Max Hz"), capacity))
        self.body_box(bodys)

        self.tag_box(_("Core Info"))
        del bodys[:]
        bodys.append((_("Version"), version))
        #threads = cpuinfo()
        threads = config.get("threads")
        cpunums = config.get("cores")
        if cpunums:
            cpunums = cpunums + _("core") + "/" + threads + _("thread")
            bodys.append((_("Core Num"), cpunums))
        bodys.append((_("Slot"), slot))
        if width:
           bodys.append((_("Width"),str(width) + _("bit")))
        bodys.append((_("Serial"), serial))

        text = ",".join(capability)
        bodys.append((_("Order"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor, product)

        self.tag_box(_("Cache Info"))
        del bodys[:]
        data = GetCpuCacheInfo()
        l1cache = data["L1d"]
        l2cache = data["L1i"]
        l3cache = data["L2"]
        bodys.append((_("L1 cache"), l1cache))
        bodys.append((_("L2 cache"), l2cache))
        bodys.append((_("L3 cache"), l3cache))
        self.body_box(bodys) 

class Cache(Computer):

    category = "cache"
    def __init__(self, description, product, vendor, version, slot, size):
        Computer.__init__(self, product)
        bodys = []
        if size:
            size = str(int(size) / 1024) + "KB"
            bodys.append((_(description), size))
            self.body_box(bodys)

class Memory(Computer):

    category = "memory"

    def __init__(self, description, product, vendor, version, slot, size):
        Computer.__init__(self, product)

        if description == "RAM memory":
            return

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("MDescription"), _(description)))

        if size:
            size = F(float(size) / 1024**3) + "GB"
            bodys.append((_("Size"), size))
        self.body_box(bodys)

class Bank(Computer):

    category = "bank"

    def __init__(self, description, product, vendor, version, serial, slot, size, width, clock):
        Computer.__init__(self, product)

        self.tag_box(_("Physical Memory"))

        bodys = []
        bodys.append((slot, description))
        bodys.append((_("Memory product"), product))
        bodys.append((_("Vendor"), _(vendor)))

        if size:
            size = F(float(size) / 1024**3) + "GB"
            bodys.append((_("Memory size"), size))

        if width:
            bodys.append((_("Width"), width + _("bit")))

        bodys.append((_("Serial"), serial))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Display(Computer):

    category = "display"

    def __init__(self, description, product, vendor, version, businfo, config, capability):
        Computer.__init__(self, product)

        try:
            ID = re.findall("\[(.*)\]", vendor[-6:])[0]
        except:ID = "8086"
        if ID == "1002" or ID == "10DE":
            cardtype = _("Graphics card")
        else:
            cardtype = _("Integrated graphics")

        self.title_box(cardtype + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Display card"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        self.body_box(bodys)

        self.tag_box((_("Expand Info")))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Display driver"), config.get("driver")))

        text = ",".join(capability)
        bodys.append((_("Display cap"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Monitor(Computer):

    category = "monitor"

    def __init__(self, description, product, vendor, version):
        Computer.__init__(self, product)

        dict = get_monitor()

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        product = dict.get("product")
        if product:
            bodys.append((_(self.category), product.upper()))

        vendor = dict.get("vendor", '')
        bodys.append((_("Vendor"), _(vendor)))

        year = dict.get("year")
        week = dict.get("week")
        if year and week:
            bodys.append((_("Make time"), _("%s year num %s week") %(year,week)))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Apparent Area"), dict.get("size")))

        inch = dict.get("in")
        if inch:
            bodys.append((_("Dimension"), inch + _("inches")))

        ratio = get_ratio()
        if ratio:
            bodys.append((_("Current resolution"), ratio))

#       bodys.append((_("Max resolution"), dict.get("maxmode")))
        bodys.append((_("Gamma"), dict.get("gamma")))
        bodys.append((_("Current output"), dict.get("output")))

        support = dict.get("support output")
        if support:
            text = ",".join(support)
            bodys.append((_("Support output"), text))

        bodys.append((_("Current chip"), dict.get("chip")))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Modem(Computer):

    category = "generic"

    def __init__(self, description, product, vendor, version, businfo, serial, config, capability):
        Computer.__init__(self, product)

        if description:
            self.title_box(_(description))
        else:
            self.title_box(_(self.category))
        self.tag_box(_("Basic Info"))

        bodys = []
        if product:
            bodys.append((_("Name"), product))
        else:
            bodys.append((_("Name"), description))

        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        bodys.append((_("Serial"), serial))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Driver"), config.get("driver")))
        bodys.append((_("Max power"), config.get("maxpower")))
        bodys.append((_("Speed"), config.get("speed")))

        text = ",".join(capability)
        bodys.append((_("Capability"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Multimedia(Computer):

    category = "multimedia"

    def __init__(self, description, product, vendor, version, businfo, config, capability):
        Computer.__init__(self, product)

        if description:
            self.title_box(_(description) + _("Info"))
        else:
            self.title_box(_("Audio device") + _("Info"))

        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Name"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Driver"), config.get("driver")))
        bodys.append((_("Max power"), config.get("maxpower")))
        bodys.append((_("Speed"), config.get("speed")))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Network(Computer):

    category = "network"

    def __init__(self, description, product, vendor, version, businfo, logicalname, serial, capacity, config, capability):
        Computer.__init__(self, product)

        if description != "Ethernet interface" and description != "Wireless interface":
            return

        nettype = description.split(" ")[0]
        self.title_box(_(nettype) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Network name"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        bodys.append((_("Logicalname"), logicalname))
        bodys.append((_("MAC addr"), serial.upper()))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))

        if capacity:
            maxwidth = str(int(capacity) / 1000000) + "Mbps"
            bodys.append((_("Max width"), maxwidth))

        bodys.append((_("Network driver"), config.get("driver")))
        bodys.append((_("Driver ver"), config.get("driverversion")))
        bodys.append((_("IP addr"), config.get("ip")))
        bodys.append((_("Link"), config.get("link", _("Empty"))))
        bodys.append((_("Wireless spec"), config.get("wireless")))

        text = ",".join(capability)
        bodys.append((_("Network cap"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Disk(Computer):

    category = "disk"

    def __init__(self, description, product, vendor, version, businfo, logicalname, serial, size, config, capability):
        Computer.__init__(self, product)

        if not size:
            return
        #self.debug_dm("disk v:" + vendor + "p:" + product + "\n")
        oriproduct=product
        if not vendor:
            vendor = get_disk_vendor(logicalname)
            serial = get_disk_serial(logicalname)

        self.title_box(_(description) + _("Info"))

        if not serial:
            process = os.popen("find /sys/devices/ | grep wwid |xargs cat 2>/dev/null | awk -F' ' '{print $NF}'|head -n1") # return file
            output = process.read()
            process.close()
            serial = output

        process = os.popen("udevadm info " + logicalname + " | grep ID_MODEL= | sed -e 's/.*ID_MODEL=//g'")
        output = process.read()
        process.close()
        product = output

        if description == "ATA Disk":
            dict = udisks(logicalname)

            self.tag_box(_("Basic Info"), logicalname)#dict.get("temp"))

            bodys = []
            if vendor:
                bodys.append((_("DProduct"), _(vendor) + " " + product[:-1]))
            else:
                bodys.append((_("DProduct"), product[:-1]))

            if size:
                size = str(int(size) // 1000**3) + "GB"
                bodys.append((_("DCapacity"), size))

            bodys.append((_("Rotate speed"), dict.get("rota")))
            bodys.append((_("Bus addr"), businfo))
            bodys.append((_("Logicalname"), logicalname))
            bodys.append((_("Serial"), serial))
            self.body_box(bodys)
            '''
            self.tag_box(_("S.M.A.R.T"))

            del bodys[:]
            bodys.append((_("Last time"), dict.get("boot")))

            sumtime = dict.get("sumtime")
            sumnub = dict.get("sumnub")
            if sumnub and sumtime:
                bodys.append((_("Use"), _("Sum use %s,total %s") %(sumnub, sumtime)))

            bodys.append((_("Err sector num"), dict.get("unsect")))
            bodys.append((_("Disk status"), _(dict.get("state"))))
            bodys.append((_("Firmware"), version))

            wwn = dict.get("wwn")
            if wwn:
                bodys.append((_("WWN"), wwn.upper()))
            self.body_box(bodys)
            '''
            self.logo = self.dev_logo(vendor, oriproduct)

        elif description == "NVME Disk":
            self.tag_box(_("Basic Info"))

            bodys = []
            if vendor :
                bodys.append((_("DProduct"), _(vendor) ))
                
            bodys.append((_("DCapacity"), size))
            bodys.append((_("Bus addr"), businfo))
            bodys.append((_("Logicalname"), logicalname))
            if serial:
                bodys.append((_("Serial"), serial))
            self.body_box(bodys)
            self.logo = self.dev_logo(vendor, oriproduct)

        else:
            self.tag_box(_("Basic Info"))

            bodys = []
            if vendor and product[:-1]:
                bodys.append((_("DProduct"), _(vendor) + " " + product[:-1]))
            if size:
                size = F(float(size) / 1000**3) + "GB"
                bodys.append((_("Capacity"), size))

            bodys.append((_("Bus addr"), businfo))
            bodys.append((_("Logicalname"), logicalname))
            if serial:
                bodys.append((_("Serial"), serial))
            self.body_box(bodys)
            self.logo = self.dev_logo(vendor, oriproduct)

class Storage(Computer):

    category = "storage"

    def __init__(self, description, product, vendor, version, businfo, logicalname, serial, config, capability):
        Computer.__init__(self, product)

        if description:
            self.title_box(_(description) + _("Info"))
        else:
            self.title_box(_(self.category) + _("Info"))

        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Name"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Serial"), serial))
        bodys.append((_("Bus addr"), businfo))
        bodys.append((_("Logicalname"), logicalname))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Driver"), config.get("driver")))
        bodys.append((_("Max power"), config.get("maxpower")))
        bodys.append((_("Speed"), config.get("speed")))

        text = ",".join(capability)
        bodys.append((_("Capability"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Cdrom(Computer):

    category = "cdrom"

    def __init__(self, description, product, vendor, version, businfo, logicalname, config, capability):
        Computer.__init__(self, product)

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Cdrom name"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        bodys.append((_("Logicalname"), logicalname))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))

        status = config.get("status")
        bodys.append((_("Dev status"), _(status)))

        text = ",".join(capability)
        bodys.append((_("Cdrom cap"), text))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Imput(Computer):

    category = "input"

    def __init__(self, description, product, vendor, version, businfo, config, capability):
        Computer.__init__(self, product)

        self.title_box(_(description) + _("Info"))
        self.tag_box(_("Basic Info"))

        bodys = []
        bodys.append((_("Name"), product))
        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Driver"), config.get("driver")))
        bodys.append((_("Max power"), config.get("maxpower")))
        bodys.append((_("Speed"), config.get("speed")))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)


class Power(Computer):

    category = "battery"

    def __init__(self, description, product, vendor, version, slot, capacity, config):
        Computer.__init__(self, product)

        self.title_box(_(self.category) + _("Info"))
        self.tag_box(_("Basic Info"))

        print ("product is:%s(read from BIOS)" % product)
        product = os.popen("cat /sys/class/power_supply/BAT*/model_name|awk '{print $1}'").read()
        if (0 != len(product)):
            product = product[:-1]
            print ("product is:%s(read from file)" % product)
        print ("vendor is:%s(read from BIOS)" % vendor)
        vendor = os.popen("cat /sys/class/power_supply/BAT*/manufacturer|awk '{print $1}'").read()
        if (0 != len(vendor)):
            vendor = vendor[:-1]
            print ("vendor is:%s(read from file)" % vendor)

        bodys = []
        if (0 != len(product)):
            bodys.append((_("Name"), product))
        if (0 != len(vendor)):
            bodys.append((_("Vendor"), vendor))

        if capacity:
            text = str(float(capacity) / 1000) + "Wh"
            bodys.append((_("Bcapacity"), text))

        bodys.append((_("voltage"), config.get("voltage")))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)

class Generic(Computer):

    category = "generic"

    def __init__(self, description, product, vendor, version, businfo, serial, config, capability):
        Computer.__init__(self, product)

        if description:
            self.title_box(_(description))
        else:
            self.title_box(_(self.category))
        self.tag_box(_("Basic Info"))

        bodys = []
        if product:
            bodys.append((_("Name"), product))
        else:
            bodys.append((_("Name"), description))

        bodys.append((_("Vendor"), vendor))
        bodys.append((_("Bus addr"), businfo))
        self.body_box(bodys)

        self.tag_box(_("Expand Info"))

        del bodys[:]
        bodys.append((_("Firmware"), version))
        bodys.append((_("Driver"), config.get("driver")))
        bodys.append((_("Serial"), serial))
        bodys.append((_("Max power"), config.get("maxpower")))
        bodys.append((_("Speed"), config.get("speed")))
        self.body_box(bodys)

        self.logo = self.dev_logo(vendor)
