#!/usr/libexec/platform-python
# -*- coding:utf-8 -*-
#__author__="hechao"
#__date__ ="$2012-3-8 10:12:56$"

import os
#import gtk
import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk
from gi.repository import Gdk
from gi.repository import GdkPixbuf
import time
#import gobject
from gi.repository import GObject
from threading import Thread

from globals import *
from syscall import *
from widgets import BaseFucn
from devices import Device
from dbuscall import init_dbus

import cairo
import gettext
gettext.textdomain('ydm')
def _(s):
    return gettext.gettext(s)


class DeviceThread(Thread, GObject.GObject, BaseFucn):
    __gsignals__ = {
        'load-wait': (GObject.SIGNAL_RUN_LAST, GObject.TYPE_NONE, ())
    }

    def __init__(self, ydmg, flag=None):
        Thread.__init__(self)
        GObject.GObject.__init__(self)

        self.setDaemon(True)
        self.flag = flag
        ydmg.lock = True
        self.base = ydmg

    def run(self):
        '''Wait'''
        self.base.framebox.add(self.load_wait(self.base, "Loading, please wait ..."))
        if not os.path.isfile(HW_XML) or not os.path.getsize(HW_XML) or self.flag == "DET":
            '''set timeout is 600s, the default is 25s'''
            #lockfile = "/tmp/ydmnfschinayl.lock"
            #ltime = 0
            #while os.path.isfile(lockfile):
            #    time.sleep(2)
            #    ltime += 1 
            #else:
            #    os.mknod(lockfile)
            #    if ltime > 0:
            #        time.sleep(2)
            iface = init_dbus()
            data = iface.scan_device(timeout=600)
            with open(HW_XML,"w") as fp:
                fp.write(data)
            iface.quit_loop()
            #os.remove(lockfile)
        device = Device(HW_XML)
        self.dev_dict = device.dev_type
        self.base.pcid = device.pcid

        self.base.device_page = DevicePage(self.dev_dict, self.base)
        self.emit('load-wait')
        self.base.select_page(DEV_ID)
        self.base.lock = False

class DevicePage(Gtk.VBox):

    def __init__(self, dev_dict, base):
        Gtk.VBox.__init__(self)

        contentbox = Gtk.HBox()

        #t add
        contentbox1 = Gtk.HBox()
        contentbox1.set_size_request(DEF_INDEXWD, DEF_HEIGHT)
        self.align1 = Gtk.Alignment.new(0, 0, 0, 0)
        self.align1.add(contentbox1)
        self.categorybox = DeviceCategory(dev_dict, self.select, base)
        contentbox1.pack_start(self.categorybox, False, False, 0)

        contentbox2 = Gtk.HBox()
        contentbox2.set_size_request(DEF_DCONTWD, DEF_HEIGHT)
        contentbox2.set_resize_mode(1)
        self.align2 = Gtk.Alignment.new(0, 0, 0, 0)
        self.align2.add(contentbox2)
        self.contentview = DeviceContent(dev_dict)
        contentbox2.pack_start(self.contentview, False, False, 0)

        contentbox3 = Gtk.HBox()
        contentbox3.set_size_request(DEF_LOGOWD, DEF_HEIGHT)
        self.align3 = Gtk.Alignment.new(0, 0, 0, 0)
        self.align3.add(contentbox3)
        self.logoview = DeviceLoge(dev_dict)
        contentbox3.pack_start(self.logoview, False, False, 0)

        contentbox.pack_start(self.align1, False, False, 0)
        contentbox.pack_start(self.align2, False, False, 0)
        contentbox.pack_start(self.align3, False, False, 0)
        #end txn

        #tip bar
        #powerain
        #tipbar = DeviceBar(base)
        #self.pack_start(tipbar, False)

        #category box --> content view --> logo view
        #self.categorybox = DeviceCategory(dev_dict, self.select, base)
        #contentbox.pack_start(self.categorybox, False, False, 0)
        #self.contentview = DeviceContent(dev_dict)
        #contentbox.pack_start(self.contentview, False, False, 0)
        #self.logoview = DeviceLoge(dev_dict)
        #contentbox.pack_start(self.logoview, False, False, 0)

        self.pack_start(contentbox, False, False, 0)

        #powerain
        tipbar = DeviceBar(base)
        self.pack_start(tipbar, False, False, 0)

        self.show_all()

    def select(self, widget, key):

        self.categorybox.categoryid = key
        #Image change, queue_draw() trigger expose()
        self.categorybox.queue_draw()
        self.contentview.updates(key)
        self.logoview.updates(key)


class DeviceBar(Gtk.EventBox, BaseFucn):

    def __init__(self, base):
        Gtk.EventBox.__init__(self)
        #self.connect("expose_event", self.expose_ebox, ICON + "tip.png")
        self.base = base

        bar_box = Gtk.HBox()
        #align = self.define_align(bar_box, 0.5, 0.5, 1, 1)
        align = self.define_align(bar_box, 1, 0, 0, 0)
        align.set_padding(5, 3, 10, 10)
        self.add(align)

        tip_label = Gtk.Label()
        t = time.localtime(os.stat(HW_XML).st_mtime)
        date = time.strftime("%Y-%m-%d %H:%M:%S", t)
        tip_label.set_markup("<span font_desc='10'>%s</span>" % _("Date of last detection: ") + \
                            "<span color='red' font_desc='10'>%s</span>" % date)
        bar_box.pack_start(tip_label, False, False, 0)

        '''DET'''
        retest = self.re_tested("DET")
        bar_box.pack_start(retest, False, False, 20)
        #bar_box.pack_start(retest, True, False)
        self.override_background_color(Gtk.StateFlags.NORMAL, Gdk.RGBA(0.96,0.96,0.96,1))

        '''Save screenshot'''
        #screenshot = self.report_scrot(ICON + "scrot.png", _("Save screenshot"), "SCROT")
        #bar_box.pack_end(screenshot, False, False)

        '''Save report'''
        #report = self.report_scrot(ICON + "report.png", _("Generate reports"), "REPORT")
        #bar_box.pack_end(report, False, False, 20)

    def re_tested(self, has_tap):

        #button = self.ebox_button()
        button = Gtk.Button(_("Re-detect"))
        button.set_size_request(70, 30)
        button.connect('button-release-event', self.on_click, has_tap)

        #label = gtk.Label()
        #label.set_markup("<span foreground='#0092CE' font_desc='10'>%s</span>" % _("Re-detect"))

        #button.add(label)
        #button.set_use_stock(True)
        #button.set_label(_("Re-detect"))
        return button

    def report_scrot(self, iconpath, txt, has_tap):

        button = self.ebox_button()
        #button = gtk.button
        button.connect('button-release-event', self.on_click, has_tap)

        icon = Gtk.Image.new_from_file(iconpath)
        label = Gtk.Label()
        label.set_markup("<span font_desc='10'>%s</span>" % txt)

        box = Gtk.HBox()
        box.pack_start(icon, False, False, 0)
        box.pack_start(label, False, False, 4)
        button.add(box)

        return button

    def on_click(self, widget, event, has_tap):
        #print "on click"
        if not self.active_zone(widget):
                return True # Returning TRUE indicates that this event has been handled and should not spread further.

        if has_tap == "REPORT":
            self.save_file_as()
        elif has_tap == "SCROT":
            screenshot()
        elif has_tap == "DET":
            self.base.framebox.foreach(lambda widget: self.base.framebox.remove(widget))
            device_thread = DeviceThread(self.base, has_tap)
            device_thread.start()
            #bug0355946：
            device_thread.join()

    def save_file(self, fname):

        if fname:
            if xz_file():
                name = HW_XML
            else:
                name = TARGET_DIR + "/device.tar.xz"
            with open(fname, 'w') as fp:
                txt = self.read_file(name)
                fp.write(txt)
        else:
            self.save_file_as()

    def read_file(self, name):

        try:
            with open(name, 'r') as fp:
                return fp.read()
        except:
            return 'N/A'

    def save_file_as(self):

        fname = "device.tar.xz"
        chooser = Gtk.FileChooserDialog(_('Save report'),
                                        None, Gtk.FILE_CHOOSER_ACTION_SAVE,
                                        buttons=(Gtk.STOCK_CANCEL, Gtk.RESPONSE_CANCEL,
                                        Gtk.STOCK_SAVE, Gtk.RESPONSE_OK)
                                       )

        chooser.set_current_name(fname)
        folder = os.path.expanduser('~')
        chooser.set_current_folder(folder)  # set default dir

        chooser.set_local_only(True)
        chooser.set_default_response(Gtk.RESPONSE_OK)

        res = chooser.run()
        if res == Gtk.RESPONSE_OK:
            fname = chooser.get_filename()
            self.save_file(fname)
        elif res == Gtk.RESPONSE_CANCEL:
            chooser.destroy()
        chooser.destroy()


class DeviceCategory(Gtk.ScrolledWindow, BaseFucn):

    def __init__(self, dev_dict, func, base):
        Gtk.ScrolledWindow.__init__(self)
        self.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        self.set_shadow_type(Gtk.ShadowType.NONE)
        tab = GdkPixbuf.Pixbuf.get_file_info(ICON + "tab_h.png")
        self.set_size_request(tab[1] + 12, DEF_HEIGHT)

        self.override_background_color(Gtk.StateFlags.NORMAL, Gdk.RGBA(0.94,0.94,0.94,1))
        self.base = base
        base.window.connect("key-press-event", self.key_down)

        self.callback = func

        self.keys = list(dev_dict.keys())
        self.keys.sort()
        self.categoryid = (0, "system")

        vbox = Gtk.VBox(False)
        align = self.define_align(vbox)
        align.set_padding(10, 0, 6, 0)

        for key in self.keys:
            button = self.draw_button(_(key[1]), ICON + "%s.png" % key[1], key)
            vbox.pack_start(button, False, False, 2)

        self.add_with_viewport(align)
        #self.get_children()[0].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#F5F8FA"))

    def draw_button(self, txt, icon, key):

        button = Gtk.Button()
        button.connect("pressed", self.callback, key)

#        h_pixbuf = GdkPixbuf.Pixbuf.new_from_file(ICON + "tab_h.png")
#        p_pixbuf = GdkPixbuf.Pixbuf.new_from_file(ICON + "tab_p.png")
        h_pixbuf = cairo.ImageSurface.create_from_png(ICON + "tab_h.png")
        p_pixbuf = cairo.ImageSurface.create_from_png(ICON + "tab_p.png")

        button.set_size_request(h_pixbuf.get_width(), h_pixbuf.get_height())
        #powerain
# zzzzz        
        button.connect("draw", self.expose_tab, txt, icon, h_pixbuf, p_pixbuf, key, self.get_id)
        #button.connect("expose_event", self.expose_tab, txt, icon,  key, self.get_id)
        return button

    def get_id(self):
        return self.categoryid

    def key_down(self, widget, event):
        if self.base.pageid != DEV_ID:
            return False # Return FALSE to continue normal processing.

        i = self.categoryid[0]
        l = len(self.keys)
        if event.keyval == Gtk.keysyms.Down:
            i += 1
            if i >= l:
                self.callback(widget, self.keys[0])
            else:
                self.callback(widget, self.keys[i])
        elif event.keyval == Gtk.keysyms.Up:
            i -= 1
            if i < 0:
                self.callback(widget, self.keys[l-1])
            else:
                self.callback(widget, self.keys[i])


class DeviceContent(Gtk.ScrolledWindow):

    def __init__(self, dev_dict):
        Gtk.ScrolledWindow.__init__(self)
        self.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        self.set_shadow_type(Gtk.ShadowType.NONE)
        self.set_size_request(DEF_DCONTWD, DEF_HEIGHT)

        self.vbox = Gtk.VBox()
        self.dev_dict = dev_dict

        self.key = (0, "system")
        self.updates(self.key)

        self.add_with_viewport(self.vbox)
        self.override_background_color(Gtk.StateFlags.NORMAL, Gdk.RGBA(0.92,0.92,0.92,1))
        #self.get_children()[0].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FFFFFF"))

    def updates(self, key):

        self.remove_box(self.vbox)
        for box in self.dev_dict[key]:
            self.vbox.pack_start(box, False, False, 0)

        self.vbox.show_all()

    def remove_box(self, box):
        box.foreach(lambda widget: box.remove(widget))


class DeviceLoge(Gtk.ScrolledWindow, BaseFucn):

    def __init__(self, dev_dict):
        Gtk.ScrolledWindow.__init__(self)
        self.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        self.set_shadow_type(Gtk.ShadowType.NONE)
        self.set_size_request(200, -1)

        self.vbox = Gtk.VBox()
        label = Gtk.Label()
        label.set_markup("<span foreground='#0092CE' font_desc='10'>%s</span>" % _("Hardware Brand"))
        self.align = self.define_align(label)
        self.align.set_padding(5, 0, 5, 0)

        self.dev_dict = dev_dict

        self.key = (0, "system")
        self.updates(self.key)

        self.add_with_viewport(self.vbox)
        self.override_background_color(Gtk.StateFlags.NORMAL, Gdk.RGBA(0.94,0.94,0.94,1))
        #self.get_children()[0].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#F5F8FA"))

    def updates(self, key):

        self.remove_box(self.vbox)
        self.vbox.pack_start(self.align, False, False, 0)
        for box in self.dev_dict[key]:
            try:
                self.vbox.pack_start(box.logo, False, False, 0)
            except:
                self.vbox.show_all()

        self.vbox.show_all()

    def remove_box(self, box):
        box.foreach(lambda widget: box.remove(widget))
